dnl This file is part of MPHELL.
dnl enable MBEDTLS
dnl MPHELL_ENABLE_MBEDTLS

AC_DEFUN([MPHELL_ENABLE_MBEDTLS],
         [AC_ARG_ENABLE([mbedtls],
                        [AC_HELP_STRING([--enable-mbedtls],
                        [Use MBEDTLS for arithmetic,
                         default=no])],
                        [test_mbedtls=$enable_mbedtls],
                        [test_mbedtls=no])
          AC_MSG_CHECKING(if MBEDTLS is used for arithmetic)
          AS_IF([ test "x$test_mbedtls" != "xno" -a "x$test_gmp" == "xno" -a "x$test_ipp" == "xno"],
          [
                AC_DEFINE(USE_MBEDTLS, 1, [Define if MBEDTLS is used for arithmetic])
                AC_MSG_RESULT(yes)
                AC_DISABLE_SHARED                         # disable shared libraries
          ],
          [
                AC_DEFINE(USE_MBEDTLS, 0, [Define if MBEDTLS is not used for arithmetic])
                AC_MSG_RESULT(no)])
          ]
)
