dnl This file is part of MPHELL.
dnl enable Montgomery arithmetic
dnl MPHELL_ENABLE_MONTGOMERY

AC_DEFUN([MPHELL_ENABLE_MONTGOMERY],
         [AC_ARG_ENABLE([montgomery],
                        [AC_HELP_STRING([--enable-montgomery],
                        [Use Montgomery arithmetic (only when GMP is used),
                         default=yes])],
                        [test_montgomery=$enable_montgomery],
                        [test_montgomery=yes])
          AC_MSG_CHECKING(if Montgomery is used for arithmetic)
          AS_IF([ test "x$test_montgomery" != "xno" -a "x$test_ipp" == "xno"],
          [
                AC_DEFINE(USE_MONTGOMERY,1,[Define if Montgomery arithmetic is used])
                AC_MSG_RESULT(yes)],
          [
                AC_DEFINE(USE_MONTGOMERY,0,[Define if Montgomery arithmetic is not used])
                AC_MSG_RESULT(no)]
                )
        ]
)
