dnl This file is part of MPHELL.
dnl enable to use multithreading
dnl MPHELL_ENABLE_MULTITHREADING

AC_DEFUN([MPHELL_ENABLE_MULTITHREADING],
         [AC_ARG_ENABLE([multithreading],
                        [AC_HELP_STRING([--enable-multithreading],
                        [Use different stacks of temporary memory: STACK_1, STACK_2 (only when GMP is used),
                         default=no])],
                        [test_multithreading=$enable_multithreading],
                        [test_multithreading=no])
          AC_MSG_CHECKING(if Multithreading is allowed)
          AS_IF([ test "x$test_multithreading" != "xno" -a "x$test_ipp" == "xno"],
          [
                AC_DEFINE(USE_MULTITHREADING,1,[Define if Multithreading is allowed])
                AC_MSG_RESULT(yes)],
          [
                AC_DEFINE(USE_MULTITHREADING,0,[Define if Multithreading is not allowed (only one stack of temporary memory)])
                AC_MSG_RESULT(no)]
                )
          ]
)
