dnl This file is part of MPHELL.
dnl Check if the intel instruction rdrand is available
dnl MPHELL_CHECK_INTEL_RDRAND

AC_DEFUN([MPHELL_CHECK_INTEL_RDRAND],
         [AC_MSG_CHECKING([whether CC supports RDRAND instruction])
          AC_TRY_RUN([   #ifdef __PATHCC__
                         #include <rw/_defs.h>
                         #include <ansi/_cstddef.h>
                         #include "stddef.h"
                         #endif
                         #include <stdio.h>
                         #include <sys/stat.h>
                         #include <sys/types.h>
                         #include <stdlib.h>
                         #include <fcntl.h>
                         #include <unistd.h>
                         #include <errno.h>
                         #include <string.h>
                         #include <stdint.h>
                         #include <math.h>
                         int main ()
                         {
                                uint16_t foo = 0;
                                unsigned char ok = 0;
                                asm volatile ("rdrand %0; setc %1": "=r" (foo), "=qm" (ok));
                                return 0;
                         }],
                         [AC_MSG_RESULT(yes)
                          AC_DEFINE(USE_RDRAND,1,[Define if rdrand intel instructions is available])
                          break;],
                         [AC_MSG_RESULT([no])
                          AC_DEFINE(USE_RDRAND,0,[Define if rdrand intel instructions is not available])
                          break;],
                         [AC_MSG_RESULT(unknow)
                          echo "WARNING: You appear to be cross compiling, so there is no way to determine"
                          echo "whether your system has RDRAND and RDSEED. I am assuming it does not have."
                          AC_DEFINE(USE_RDRAND,0,[Define if rdrand intel instructions is not available])
                          break;])
])
