dnl This file is part of MPHELL.
dnl Check if the intel instruction rdseed is available
dnl MPHELL_CHECK_INTEL_RDSEED

AC_DEFUN([MPHELL_CHECK_INTEL_RDSEED],
         [AC_MSG_CHECKING([whether CC supports RDSEED instruction])
          AC_TRY_RUN([   #ifdef __PATHCC__
                         #include <rw/_defs.h>
                         #include <ansi/_cstddef.h>
                         #include "stddef.h"
                         #endif
                         #include <stdio.h>
                         #include <sys/stat.h>
                         #include <sys/types.h>
                         #include <stdlib.h>
                         #include <fcntl.h>
                         #include <unistd.h>
                         #include <errno.h>
                         #include <string.h>
                         #include <stdint.h>
                         #include <math.h>
                         int main () 
                         {  
                                unsigned char ok = 0;
                                uint16_t seed;
                                asm volatile ("rdseed %0; setc %1": "=r" (seed), "=qm" (ok));
                                return 0; 
                         }],
                         [AC_MSG_RESULT(yes)
                          AC_DEFINE(USE_RDSEED,1,[Define if rdseed intel instructions is available])
                          break;],
                         [AC_MSG_RESULT([no])
                          AC_DEFINE(USE_RDSEED,0,[Define if rdseed intel instructions is not available])
                          break;],
                         [AC_MSG_RESULT(unknow)
                          echo "WARNING: You appear to be cross compiling, so there is no way to determine"
                          echo "whether your system has RDSEED and RDSEED. I am assuming it does not have."
                          AC_DEFINE(USE_RDSEED,0,[Define if rdseed intel instructions is not available])
                          break;])
])
